Report OpenSSL build date too.
[exim.git] / src / scripts / Configure-Makefile
1 #! /bin/sh
2
3 # Shell script to build Makefile in a build directory. It must be called
4 # from inside the directory. It does its own checking of when to rebuild; it
5 # just got too horrendous to get it right in "make", because of the optionally
6 # existing configuration files.
7
8
9 # First off, get the OS type, and check that there is a make file for it.
10
11 ostype=`../scripts/os-type -generic` || exit 1
12
13 if [ ! -r ../OS/Makefile-$ostype ] ; then
14 echo ""
15 echo "*** Sorry - operating system $ostype is not supported"
16 echo "*** See OS/Makefile-* for supported systems" 1>&2
17 echo ""
18 exit 1
19 fi
20
21 # We also need the architecture type, in order to test for any architecture-
22 # specific configuration files.
23
24 archtype=`../scripts/arch-type` || exit 1
25
26 # Now test for either the non-existence of Makefile, or for any of its
27 # components being newer. Note that the "newer" script gives the right
28 # answer (for our purposes) when the first file is non-existent.
29
30 editme=../Local/Makefile
31 rebuild=yes
32
33 if [ -f Makefile ] ; then
34 rebuild=no
35 if ../scripts/newer $editme Makefile || \
36 ../scripts/newer $editme-$ostype Makefile || \
37 ../scripts/newer $editme-$archtype Makefile || \
38 ../scripts/newer $editme-$ostype-$archtype Makefile || \
39 ../scripts/newer ../scripts/Configure-Makefile Makefile || \
40 ../scripts/newer ../OS/Makefile-Base Makefile || \
41 ../scripts/newer ../OS/Makefile-Default Makefile
42 then
43 rebuild=yes
44 fi
45 fi
46
47 # If the "build" variable is set it means that a build name was explicitly
48 # given. Arrange to pick up a build-specific configuration file.
49
50 if [ "X$build" != "X" ] ; then
51 mfb=Local/Makefile-$build
52 if ../scripts/newer $editme-$build Makefile ; then
53 rebuild=yes
54 fi
55 else
56 mfb=
57 fi
58
59
60 # If Makefile is up-to-date, no need to rebuild it.
61
62 if [ $rebuild = no ] ; then
63 echo "\`Makefile' is up to date."
64 echo " "
65 exit
66 fi
67
68 # Makefile needs to be rebuilt in the current directory by joining
69 # the generic default makefile, the OS base makefile, and then local
70 # generic, OS-specific, architecture-specific, and OS+architecture-specific
71 # makefiles, if they exist. These files all contain macro definitions, with
72 # later definitions overriding earlier ones. Make a temporary file first, in
73 # case things go wrong. A second temporary is needed for sorting out the
74 # default Perl stuff. Use short macro names to save typing.
75
76 mf=Makefile
77 mft=$mf-t
78 mftt=$mf-tt
79
80 look_mf=lookups/Makefile
81 look_mf_pre=${look_mf}.predynamic
82 look_mf_post=${look_mf}.postdynamic
83
84 # Ensure the temporary does not exist and start the new one by setting
85 # the OSTYPE and ARCHTYPE variables.
86
87 rm -f $mft $mftt $look_mf-t
88 (echo "OSTYPE=$ostype"; echo "ARCHTYPE=$archtype"; echo "") > $mft || exit 1
89
90 # Now concatenate the files to the temporary file. Copy the files using sed to
91 # remove comments, blank lines, and trailing white space.
92
93 # BEWARE: a tab character is needed in the sed command below. It has had
94 # a nasty tendency to get lost in the past, causing a problem if a tab has
95 # actually been present in one of the files. Use a variable to hold a space
96 # and a tab to keep the tab in one place.
97
98 st=' '
99
100 for f in OS/Makefile-Default \
101 OS/Makefile-$ostype \
102 Local/Makefile \
103 Local/Makefile-$ostype \
104 Local/Makefile-$archtype \
105 Local/Makefile-$ostype-$archtype \
106 $mfb
107 do if test -r ../$f
108 then echo "# From $f"
109 sed "/^#/d;/^[$st]*\$/d;s/[$st]*\$//" ../$f || exit 1
110 echo "# End of $f"
111 echo ""
112 fi
113 done >> $mft || exit 1
114
115 # handle pkg-config
116 # beware portability of extended regexps with sed.
117
118 egrep "^[$st]*(AUTH|LOOKUP)_[A-Z0-9_]*[$st]*=[$st]*" $mft | \
119 sed "s/[$st]*=/='/" | \
120 sed "s/\$/'/" > $mftt
121 egrep "^[$st]*((USE_(OPENSSL|GNUTLS)_PC)|SUPPORT_TLS|USE_GNUTLS|PCRE_CONFIG|AVOID_GNUTLS_PKCS11)[$st]*=[$st]*" $mft | \
122 sed "s/[$st]*=/='/" | \
123 sed "s/\$/'/" >> $mftt
124 if test -s $mftt
125 then
126 (
127 echo "# pkg-config fixups"
128 . ./$mftt
129 for var in `cut -d = -f 1 < $mftt`; do
130 case $var in
131
132 USE_*_PC)
133 eval "pc_value=\"\$$var\""
134 need_this=''
135 if [ ".$SUPPORT_TLS" = "." ]; then
136 # no TLS, not referencing
137 true
138 elif [ ".$var" = ".USE_GNUTLS_PC" ] && [ ".$USE_GNUTLS" != "." ]; then
139 need_this=t
140 elif [ ".$var" = ".USE_OPENSSL_PC" ] && [ ".$USE_GNUTLS" = "." ]; then
141 need_this=t
142 fi
143 if [ ".$need_this" != "." ]; then
144 tls_include=`pkg-config --cflags $pc_value`
145 tls_libs=`pkg-config --libs $pc_value`
146 echo "TLS_INCLUDE=$tls_include"
147 echo "TLS_LIBS=$tls_libs"
148 fi
149 ;;
150
151 *_PC)
152 eval "pc_value=\"\$$var\""
153 base=`echo $var | sed 's/_PC$//'`
154 eval "basevalue=\"\$$base\""
155 if [ ".$basevalue" = "." ]; then
156 # not pulling in this module, _PC defined as default? Ignore
157 true
158 elif [ $basevalue = 2 ]; then
159 # module; handled in scripts/lookups-Makefile
160 true
161 else
162 # main binary
163 cflags=`pkg-config --cflags $pc_value`
164 libs=`pkg-config --libs $pc_value`
165 if [ "$var" != "${var#LOOKUP_}" ]; then
166 echo "LOOKUP_INCLUDE += $cflags"
167 echo "LOOKUP_LIBS += $libs"
168 elif [ "$var" != "${var#AUTH_}" ]; then
169 echo "CFLAGS += $cflags"
170 echo "AUTH_LIBS += $libs"
171 else
172 echo >&2 "Don't know how to handle pkg-config for $var"
173 fi
174 fi
175 ;;
176
177 PCRE_CONFIG)
178 case $PCRE_CONFIG in
179 yes|YES|y|Y)
180 cflags=`pcre-config --cflags`
181 libs=`pcre-config --libs`
182 if [ ".$cflags" != "." ]; then
183 echo "INCLUDE += $cflags"
184 fi
185 echo "PCRE_LIBS=$libs"
186 ;;
187 esac
188 ;;
189
190 AVOID_GNUTLS_PKCS11)
191 echo "$var=yes"
192 ;;
193
194 esac
195 done
196 echo "# End of pkg-config fixups"
197 echo
198 ) >> $mft
199 fi
200 rm -f $mftt
201
202 # make the lookups Makefile with the definitions
203 # the auxiliary script generates $look_mf_post from $look_mf_pre
204
205 cp ../src/lookups/Makefile $look_mf_pre
206 ../scripts/lookups-Makefile
207
208 # See if there is a definition of EXIM_PERL in what we have built so far.
209 # If so, run Perl to find the default values for PERL_CC, PERL_CCOPTS,
210 # and PERL_LIBS. These need to be put at the top of the Makefile, so we rename
211 # what we have so far and then copy it afterwards. Use the value of PERL_COMMAND
212 # if it has been defined.
213
214 EXIM_PERL=`grep EXIM_PERL $mft`
215
216 PERL_COMMAND=`grep PERL_COMMAND $mft | sed -e "\\$!d;s/^[$st]*PERL_COMMAND[$st]*=[$st]*//"`
217 if [ "${PERL_COMMAND}" = "" ] ; then
218 PERL_COMMAND='perl'
219 fi
220
221 if [ "${EXIM_PERL}" != "" ] ; then
222 testperl=`$PERL_COMMAND --version`
223 if [ "$testperl" = "" ] ; then
224 echo "*** EXIM_PERL is set, but '$PERL_COMMAND --version' failed"
225 exit 1
226 fi
227
228 EXTUTILS_EMBED_NOT_INSTALLED=`$PERL_COMMAND -MExtUtils::Embed -e ";" 2>&1`
229 if [ "${EXTUTILS_EMBED_NOT_INSTALLED}" != "" ] ; then
230 echo "Please install ExtUtils::Embed for $PERL_COMMAND"
231 exit 1;
232 fi
233
234 mv $mft $mftt
235 echo "PERL_CC=`$PERL_COMMAND -MConfig -e 'print $Config{cc}'`" >>$mft
236 echo "PERL_CCOPTS=`$PERL_COMMAND -MExtUtils::Embed -e ccopts`" >>$mft
237 echo "PERL_LIBS=`$PERL_COMMAND -MExtUtils::Embed -e ldopts`" >>$mft
238 echo "" >>$mft
239 cat $mftt >> $mft
240 rm -f $mftt
241 fi
242
243 # Record the build variable in the Makefile.
244
245 echo "build=$build" >>$mft
246 echo "" >>$mft
247
248 # Finally, join on the generic base make file, which contains the actual
249 # rules and stuff.
250
251 echo "# From ../OS/Makefile-Base" >> $mft
252 cat ../OS/Makefile-Base >> $mft || exit 1
253
254 # If the new makefile is the same as the existing one, say so, and just
255 # update the timestamp. Otherwise remove the old and install the new.
256
257 if [ -s $mf ] && cmp -s $mft $mf && [ -s $look_mf ] && cmp -s $look_mf_post $look_mf
258 then echo ">>> rebuilt $mf unchanged"
259 echo " "
260 touch $mf || exit
261 rm -f $mft $look_mf_pre $look_mf_post
262 elif rm -f $mf $look_mf $look_mf_pre
263 mv $mft $mf
264 mv $look_mf_post $look_mf
265 then echo ">>> New $mf & $look_mf installed"
266 echo '>>> Use "make makefile" if you need to force rebuilding of the makefile'
267 echo " "
268 else echo " "
269 echo "*** Failed to install $mf - see $mft"
270 echo " (or $look_mft)"
271 echo " "
272 exit 1;
273 fi
274
275 # vim: set ft=sh :
276 # End of Configure-Makefile